<template>
  <q-card class="q-mt-sm" flat bordered>
    <div v-if="table" :key="language_switch" role="region" aria-label="Table definition">
      <q-card-section class="text-primary table_table_heading text-weight-bold">
        <div v-if="table" v-html="show_label(table)" role="heading"></div>
      </q-card-section>
      <q-item-label title="table ID" class="q-pa-sm" caption>{{ table.id }}</q-item-label>

      <div v-for="breakdown in table.table_breakdowns"
           v-bind:key="breakdown.label" role="region" aria-label="Table breakdown">
        <div class="q-ma-md breakdown">
          <q-card-section class="detail_bg" role="presentation">
            {{ breakdown.axis.toUpperCase() }}-axis {{ breakdown.parent_child_order }}
            <q-item-label caption>{{ showLabel(breakdown) }}</q-item-label>
          </q-card-section>
          <div v-for="concept_relation in breakdown.concept_relationshipnodes"
               v-bind:key="concept_relation.label" class="q-pl-md" role="region" aria-label="Concept Relationship">
            {{ showLabel(concept_relation) }} - {{ concept_relation.parent_child_order }} -
            <div class="text-caption">Concept relationship node</div>
          </div>
          <div v-for="dimension_relation in breakdown.dimension_relationshipnodes"
               v-bind:key="dimension_relation.label" class="q-pl-md" role="region" aria-label="Dimension Relationship">
            {{ showLabel(dimension_relation) }} - {{ dimension_relation.parent_child_order }} -
            <div class="text-caption">Dimension relationship node</div>
          </div>
          <div v-for="aspect_node in breakdown.aspect_nodes"
               v-bind:key="aspect_node.label" class="q-pl-md" role="region" aria-label="Aspect">
            {{ showLabel(aspect_node) }} - {{ aspect_node.parent_child_order }} -
            <div class="text-caption">Aspect node</div>
          </div>
          <template v-if="breakdown.table_rulenodes.length > 0">
            <RuleNode v-for="rule_node in breakdown.table_rulenodes"
                      v-bind:key="rule_node.label"
                      v-bind:rule_node="rule_node"
                      role="region" aria-label="Table Rulenode">
            </RuleNode>
          </template>
        </div>
      </div>
    </div>
  </q-card>
</template>

<script>
import RuleNode from "components/RuleNode"
import SharedMethods from "components/SharedMethods";

export default {
  name: "TableDetailCard",
  components: {RuleNode},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  data() {
    return {
      language_switch: 0
    }
  },
  props: {
    table: Object
  },
  methods: {
    showLabel: function (node) {
      // get_label fails silently, here we know we don't always have labels, hence fallback
      let label = this.get_label(node)
      if (label.length > 0) {
        return label
      }
      return node.label
    }
  },
  watch: {
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  }
}
</script>

<style scoped lang="scss">
.table_table_heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
}

.detail--padding {
  padding: 30px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

table {
  border-spacing: 5px;
  width: 100%;
}

th {
  text-align: left;
}

</style>
